#include <stdio.h>

#include <allegro.h>

int main(int argc, char *argv[]) {
int err = 0, vSize=5, hSize=5, color=0, i, eq=0, nv, nh;
BITMAP *source;
BITMAP *dest;
PALETTE pal;

   allegro_init();

   if (argc < 2 || (!strstr(argv[1], ".pcx") && !strstr(argv[1], ".bmp") &&
                !strstr(argv[1], ".lbm") && !strstr(argv[1], ".tga"))) {
      printf("Usage: enlarge source [-border n][-h n][-v n][-color n][-eq][dest]\n");
      printf("       source is a valid pcx, lbm, tga or bmp file\n");
      printf("       -border specifies the border size (default = 5)\n");
      printf("       -h specifies the horizontal enlargement\n");
      printf("       -v specifies the vertical enlargement\n");
      printf("       -color specifies the border color (default = 0)\n");
      printf("       -eq first makes the bitmap square\n");
      printf("       dest is the optional new filename\n");
      return -1;
   }

   for (i = 2; i < argc; i++) {
       if (!stricmp(argv[i], "-border") && i < argc-1) {
          hSize = atoi(argv[i+1]);
          vSize = atoi(argv[i+1]);
       } else if (!stricmp(argv[i], "-color") && i < argc-1) {
         color = atoi(argv[i+1]);
       } else if (!stricmp(argv[i], "-h") && i < argc-1) {
         hSize = atoi(argv[i+1]);
       } else if (!stricmp(argv[i], "-v") && i < argc-1) {
         vSize = atoi(argv[i+1]);
       } else if (!stricmp(argv[i], "-eq")) {
         eq = 1;
       }

   } // for i

   source = load_bitmap(argv[1], pal);
   if (!source) {
      printf("Couldn't read source bitmap\n");
      return -2;
   }

   if (eq) {
      if (source->w > source->h) {
         nv = source->w;
         nh = source->w;
      } else {
         nv = source->h;
         nh = source->h;
      } // taller than wider
   } else {
     nv = source->h;
     nh = source->w;
   }

   nh += (hSize*2);
   nv += (vSize*2);

//   fprintf(stderr, "nh, nv: %i, %i; sh, sv: %i, %i\n", nh, nv, source->w, source->h);

   dest = create_bitmap(nh, nv);
   if (!dest) {
      printf("Could not create bitmap destination\n");
      return -3;
   }
   clear_to_color(dest, color);

//   blit(source, dest, 0, 0, hSize, vSize, source->w, source->h);
   blit(source, dest, 0, 0, (dest->w - source->w)/2, (dest->h-source->h)/2, source->w, source->h);

   if (argc > 2 && (strstr(argv[argc-1], ".pcx") || strstr(argv[argc-1], ".bmp") ||
            strstr(argv[argc-1], ".lbm") || strstr(argv[argc-1], ".tga"))) {
      if (save_bitmap(argv[argc-1], dest, pal) < 0) {
         printf("Could not save result\n");
      }
   } else
       if (save_bitmap(argv[1], dest, pal) < 0)
          printf("Could not save result\n");

   destroy_bitmap(source);
   destroy_bitmap(dest);

// end main
return err;
}

