#include <stdio.h>
#include <allegro.h>

int main(int argc, char *argv[]) {
int err = 0, i, start=0, end=255, map=0;
BITMAP *pic1;
BITMAP *pic2;
PALETTE p1pal;
PALETTE p2pal;
char filename[80];

   allegro_init();

   if (argc < 3) {
      printf("Usages: palcopy pic1 pic2 [-s n][-e n][-map n] [dest]\n");
      printf("        -s specifies where to begin copying\n");
      printf("        -e specifies where to end copying (inclusive)\n");
      printf("        -map lets you offset the copy index\n");
      printf("   If the last argument is a valid bitmap filename, the\n");
      printf("   result will be saved there instead of overtop pic2\n");
      return -1;
   }

   for (i = 3; i < argc; i++) {
       if (!stricmp(argv[i], "-s") && i < argc-1) {
          start = atoi(argv[i+1]);
       } else if (!stricmp(argv[i], "-e") && i < argc-1) {
          end = atoi(argv[i+1]);
       } else if (!stricmp(argv[i], "-map") && i < argc-1) {
         map = atoi(argv[i+1]);
       }
   } // for i

   pic1 = load_bitmap(argv[1], p1pal);
   pic2 = load_bitmap(argv[2], p2pal);
   if (!pic1 || !pic2) {
      printf("Could not read bitmap.\n");
      return -1;
   }

   if (start <0) {
      start = 0;
      printf("Warning: Invalid start pos\n");
   } else if (start > 255) {
      start = 255;
      printf("Warning: Invalid start pos\n");
   }
   if (end <0) {
      end = 0;
      printf("Warning: Invalid end pos\n");
   } else if (end > 255) {
      end = 255;
      printf("Warning: Invalid end pos\n");
   }

   if ((end-start) + map > 255) {
      map = 255-(end-start);
      printf("Warning: Map value invalid\n");
   }

   for (i = start; i <= end; i++) {
       p2pal[map+(i-start)].r = p1pal[i].r;
       p2pal[map+(i-start)].g = p1pal[i].g;
       p2pal[map+(i-start)].b = p1pal[i].b;
   } // for i

   if (argc > 3 && (strstr(argv[argc-1], ".pcx") || strstr(argv[argc-1], ".bmp") ||
                strstr(argv[argc-1], ".lbm") || strstr(argv[argc-1], ".tga"))) {

      strcpy(filename, argv[argc-1]);

   } else strcpy(filename, argv[2]);

   if (save_bitmap(filename, pic2, p2pal) < 0)
      printf("Could not save result\n");

   destroy_bitmap(pic1);
   destroy_bitmap(pic2);

// end main
return err;
}

